#include "acbase.h"

#include <stdio.h>
#include <math.h>
#include <assert.h>

#ifndef UNUSED
#define UNUSED( x )	x
#endif

/* \ */
typedef struct tagATTINFO
{
	LPSTR	pszName ;				/*  */
	LPSTR	pszCatPath ;			/* ̊i[JeSpX */
} ATTINFO, * LPATTINFO ;

/* \ */
typedef struct tagAUTOCREATE
{
	UINT		attInfoNum ;		/*  */
	LPATTINFO	pAttInfoArray ;		/* \̔z */
	LPSTR		pszComment ;		/* Rg */
} AUTOCREATE, * LPAUTOCREATE ;

/* \̂𐶐 */
static LPAUTOCREATE _acNew( AC_PCPICTUREINFO pPictureInfo ) ;
/* \̂j */
static void _acDelete( LPAUTOCREATE pAutoCreate ) ;

/* DllMain */
BOOL WINAPI DllMain( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved )
{
	return TRUE ;

	UNUSED( hinstDLL ) ;
	UNUSED( fdwReason ) ;
	UNUSED( lpvReserved ) ;
}

/* vOC̊T擾 */
LPCSTR WINAPI acGetSummary( void )
{
	return "EXIF瑮ƃRg𐶐B" ;
}

/* vOC̃o[W擾 */
LPCSTR WINAPI acGetVersion( void )
{
	return "0.0.1.1" ;
}

/* vOCv摜Ԃ擾 */
AC_PISTATE WINAPI acGetRequireOfPIState( void )
{
	return AC_PISB_FILEPATH | AC_PISB_FILESIZE | AC_PISB_ARCFILEIMAGE ;
}

/* nh擾 */
AC_HAC WINAPI acGetAC( AC_PCPICTUREINFO pPictureInfo, AC_HCONFIG hConfig )
{
	return _acNew( pPictureInfo ) ;

	UNUSED( hConfig ) ;
}

/* 擾 */
UINT WINAPI acGetAttNum( AC_HAC hAC )
{
	LPAUTOCREATE	pAutoCreate = (LPAUTOCREATE)hAC ;
	assert( pAutoCreate != NULL ) ;
	return pAutoCreate->attInfoNum ;
}

/* ̂擾 */
LPCSTR WINAPI acGetAttName( AC_HAC hAC, UINT index )
{
	LPAUTOCREATE	pAutoCreate = (LPAUTOCREATE)hAC ;
	assert( pAutoCreate != NULL ) ;
	assert( index < pAutoCreate->attInfoNum ) ;
	return pAutoCreate->pAttInfoArray[index].pszName ;
}

/* JeSpX擾 */
LPCSTR WINAPI acGetCatPath( AC_HAC hAC, UINT index )
{
	LPAUTOCREATE	pAutoCreate = (LPAUTOCREATE)hAC ;
	assert( pAutoCreate != NULL ) ;
	assert( index < pAutoCreate->attInfoNum ) ;
	return pAutoCreate->pAttInfoArray[index].pszCatPath ;
}

/* Rg擾 */
LPCSTR WINAPI acGetComment( AC_HAC hAC )
{
	LPAUTOCREATE	pAutoCreate = (LPAUTOCREATE)hAC ;
	assert( pAutoCreate != NULL ) ;
	return pAutoCreate->pszComment ;
}

/* nhJ */
void WINAPI acReleaseAC( AC_HAC hAC )
{
	_acDelete( (LPAUTOCREATE)hAC ) ;
}

/********************************************************************************************/
/*	֐																				*/
/********************************************************************************************/

/* GfBAlĒl擾 */
static WORD _acGetWORD( LPCBYTE pBuffer, BOOL bBigEndian )
{
	if ( bBigEndian )
		return (WORD)( ( pBuffer[0] << 8 ) | ( pBuffer[1] << 0 ) ) ;
	return *(WORD *)pBuffer ;
}
static DWORD _acGetDWORD( LPCBYTE pBuffer, BOOL bBigEndian )
{
	if ( bBigEndian )
		return (DWORD)( ( pBuffer[0] << 24 ) | ( pBuffer[1] << 16 ) | ( pBuffer[2] << 8 ) | ( pBuffer[3] << 0 ) ) ;
	return *(DWORD *)pBuffer ;
}

/* ǉ */
static void _acAddAttInfo( LPAUTOCREATE pAutoCreate, LPCSTR pszName, LPCSTR pszCatPath )
{
	ATTINFO		attInfo ;
	size_t		len ;

	/* 񏉊 */
	len = strlen( pszName ) ;
	if ( len == 0 )
		return ;
	attInfo.pszName = (LPSTR)malloc( len + 1 ) ;
	if ( attInfo.pszName == NULL )
		return ;
	memcpy( attInfo.pszName, pszName, len + 1 ) ;
	attInfo.pszCatPath = NULL ;
	if ( pszCatPath != NULL )
	{
		len = strlen( pszCatPath ) ;
		if ( len > 0 )
		{
			attInfo.pszCatPath = (LPSTR)malloc( len + 1 ) ;
			if ( attInfo.pszCatPath != NULL )
				memcpy( attInfo.pszCatPath, pszCatPath, len + 1 ) ;
		}
	}

	/* ǉ */
	assert( pAutoCreate != NULL ) ;
	if ( pAutoCreate->attInfoNum == 0 )
	{
		assert( pAutoCreate->pAttInfoArray == NULL ) ;
		pAutoCreate->pAttInfoArray = (LPATTINFO)calloc( 1, sizeof(ATTINFO) ) ;
		if ( pAutoCreate->pAttInfoArray == NULL )
		{
			assert( attInfo.pszName != NULL ) ;
			free( attInfo.pszName ) ;
			if ( attInfo.pszCatPath != NULL )
				free( attInfo.pszCatPath ) ;
			return ;
		}
		pAutoCreate->attInfoNum = 1 ;
	}
	else
	{
		LPATTINFO	pTemp ;

		assert( pAutoCreate->pAttInfoArray != NULL ) ;
		pTemp = (LPATTINFO)realloc( pAutoCreate->pAttInfoArray, (pAutoCreate->attInfoNum+1)*sizeof(ATTINFO) ) ;
		if ( pTemp == NULL )
		{
			assert( attInfo.pszName != NULL ) ;
			free( attInfo.pszName ) ;
			if ( attInfo.pszCatPath != NULL )
				free( attInfo.pszCatPath ) ;
			return ;
		}
		pAutoCreate->pAttInfoArray = pTemp ;
		pAutoCreate->attInfoNum ++ ;
	}
	memcpy( pAutoCreate->pAttInfoArray + pAutoCreate->attInfoNum - 1, &attInfo, sizeof(ATTINFO) ) ;
}

/* Rgݒ肷 */
static void _acSetComment( LPAUTOCREATE pAutoCreate, LPCSTR pszComment, BOOL bOverWrite )
{
	assert( pAutoCreate != NULL ) ;

	/* ㏑̏ꍇÃRgJ */
	if ( bOverWrite )
	{
		if ( pAutoCreate->pszComment != NULL )
		{
			free( pAutoCreate->pszComment ) ;
			pAutoCreate->pszComment = NULL ;
		}
	}

	/* Rgݒ */
	if ( pszComment != NULL )
	{
		size_t	len = strlen( pszComment ) ;
		if ( len == 0 )
			return ;
		if ( pAutoCreate->pszComment == NULL )	/* ㏑̏ꍇAɐ^ƂȂ */
		{
			pAutoCreate->pszComment = (LPSTR)malloc( len + 1 ) ;
			if ( pAutoCreate->pszComment == NULL )
				return ;
			memcpy( pAutoCreate->pszComment, pszComment, len + 1 ) ;
		}
		else
		{
			size_t	orgLen = 0 ;
			void *	pTemp = NULL ;

			orgLen = strlen( pAutoCreate->pszComment ) ;
			pTemp = realloc( pAutoCreate->pszComment, orgLen + 2 + len + 1 ) ;
			if ( pTemp == NULL )
				return ;
			pAutoCreate->pszComment = (LPSTR)pTemp ;
			strcat( pAutoCreate->pszComment, "\r\n" ) ;
			strcat( pAutoCreate->pszComment, pszComment ) ;
		}
	}
}

static const BYTE	SOI[]	= { 0xFF, 0xD8 } ;
static const BYTE	APP1[]	= { 0xFF, 0xE1 } ;
static const BYTE	EOI[]	= { 0xFF, 0xD9 } ;
static const BYTE	EXIF[]	= { 0x45, 0x78, 0x69, 0x66, 0x00, 0x00 } ;
static const BYTE	II[]	= { 0x49, 0x49 } ;
static const BYTE	MM[]	= { 0x4D, 0x4D } ;

/* f[^` */
typedef enum tagTYPE
{
	TYPE_BYTE		= 1,
	TYPE_ASCII		= 2,
	TYPE_USHORT		= 3, 
	TYPE_ULONG		= 4,
	TYPE_URATIONAL	= 5,
	TYPE_UNDEFINED	= 7,
	TYPE_SSHORT		= 8,
	TYPE_SLONG		= 9,
	TYPE_SRATIONAL	= 10,
} TYPE ;

/* fBNgGg\ */
typedef struct tagDIRENTRY
{
	WORD	tag ;		/* EXIF ^O */
	TYPE	type ;		/* f[^` */
	DWORD	count ;		/* f[^ */
	DWORD	value ;		/* f[^l */
	DWORD	offset ;	/* i[ItZbg */
} DIRENTRY, * LPDIRENTRY ;
typedef const DIRENTRY	* LPCDIRENTRY ;

/* fBNgGg\̂ */
static void _acInitDirEntry( LPDIRENTRY pDirEntry, LPCBYTE pApp1, long offset, BOOL bBigEndian )
{
	pDirEntry->tag		= _acGetWORD( pApp1 + offset, bBigEndian ) ;
	pDirEntry->type		= _acGetWORD( pApp1 + offset + 2, bBigEndian ) ;
	pDirEntry->count	= _acGetDWORD( pApp1 + offset + 4, bBigEndian ) ;
	memcpy( &pDirEntry->value, pApp1 + offset + 8, sizeof(pDirEntry->value) ) ;
	pDirEntry->offset	= _acGetDWORD( pApp1 + offset + 8, bBigEndian ) ;
}

/* ^O}bv}N */
#define TAG_HANDLER_NAME( tagName )	_acGet##tagName
#define BEGIN_TAG_MAP( pAutoCreate, pApp1, offset, bBigEndian )\
	LPAUTOCREATE	_pAutoCreate = pAutoCreate ;\
	LPCBYTE			_pApp1 = pApp1 ;\
	BOOL			_bBigEndian = bBigEndian ;\
	DIRENTRY		_dirEntry ;\
	_acInitDirEntry( &_dirEntry, _pApp1, offset, _bBigEndian ) ;\
	switch ( _dirEntry.tag )\
	{
#define TAG_HANDLER( tagNo, tagName )\
	case tagNo:\
		TAG_HANDLER_NAME( tagName )( _pAutoCreate, &_dirEntry, _pApp1, _bBigEndian ) ;\
		break ;
#define END_TAG_MAP()\
	}

/* ^Onhvg^Cv錾 */
static void TAG_HANDLER_NAME( Model )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian ) ;
static void TAG_HANDLER_NAME( Artist )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian ) ;
static void TAG_HANDLER_NAME( ExifIFDPointer )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian ) ;
static void TAG_HANDLER_NAME( UserComment )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian ) ;
static void TAG_HANDLER_NAME( DateTimeOriginal )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian ) ;
static void TAG_HANDLER_NAME( ShutterSpeedValue )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian ) ;
static void TAG_HANDLER_NAME( FNumber )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian ) ;
static void TAG_HANDLER_NAME( ApertureValue )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian ) ;
static void TAG_HANDLER_NAME( ISOSpeedRatings )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian ) ;
static void TAG_HANDLER_NAME( ExposureTime )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian ) ;
static void TAG_HANDLER_NAME( FocalLength )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian ) ;

/* IFD 擾Ď */
static void _acGetIFD( LPAUTOCREATE pAutoCreate, LPCBYTE pApp1, UINT offset, BOOL bBigEndian )
{
	while ( offset != 0 )
	{
		UINT	dirNum, i ;

		dirNum = _acGetWORD( pApp1 + offset, bBigEndian ) ;
		offset += 2 ;
		for ( i = 0 ; i < dirNum ; i ++, offset += 12 )
		{
			/* IFD ^O}bv */
			BEGIN_TAG_MAP( pAutoCreate, pApp1, offset, bBigEndian )
				TAG_HANDLER( 0x0110, Model )			/* 摜͋@̃f */
				TAG_HANDLER( 0x013B, Artist )			/* Җ */
				TAG_HANDLER( 0x8769, ExifIFDPointer )	/* Exif IFD ւ̃|C^ */
			END_TAG_MAP()
		}
		offset = _acGetDWORD( pApp1 + offset, bBigEndian ) ;
	}
}

/* Exif IFD 擾Ď */
static void _acGetExifIFD( LPAUTOCREATE pAutoCreate, LPCBYTE pApp1, UINT offset, BOOL bBigEndian )
{
	while ( offset != 0 )
	{
		UINT	dirNum, i ;

		dirNum = _acGetWORD( pApp1 + offset, bBigEndian ) ;
		offset += 2 ;
		for ( i = 0 ; i < dirNum ; i ++, offset += 12 )
		{
			/* Exif IFD ^O}bv */
			BEGIN_TAG_MAP( pAutoCreate, pApp1, offset, bBigEndian )
				TAG_HANDLER( 0x9286, UserComment )			/* [U[Rg */
				TAG_HANDLER( 0x9003, DateTimeOriginal )		/* 摜f[^̐ */
				TAG_HANDLER( 0x829A, ExposureTime )			/* Vb^[Xs[h */
				TAG_HANDLER( 0x9201, ShutterSpeedValue )	/* Vb^[Xs[h(APEX) */
				TAG_HANDLER( 0x829D, FNumber )				/* il */
				TAG_HANDLER( 0x9202, ApertureValue )		/* il(APEX) */
				TAG_HANDLER( 0x8827, ISOSpeedRatings )		/* ISOx */
				TAG_HANDLER( 0x920A, FocalLength )			/* Yœ_ */
			END_TAG_MAP()
		}
		offset = _acGetDWORD( pApp1 + offset, bBigEndian ) ;
	}
}

/* \̂𐶐 */
static LPAUTOCREATE _acNew( AC_PCPICTUREINFO pPictureInfo )
{
	LPAUTOCREATE	pAutoCreate = NULL ;
	HANDLE			hFile = INVALID_HANDLE_VALUE ;
	HANDLE			hFileMap = NULL ;
	LPBYTE			pFileMap = NULL ;

	LPCBYTE			pFile = (LPCBYTE)pPictureInfo->pArcFileImage ;
	DWORD			fileSize = pPictureInfo->fileSize ;
	BOOL			bBigEndian ;
	LPCBYTE			pApp1 ;
	UINT			offset ;

	/* t@Cf[^擾 */
	if ( !( pPictureInfo->state & AC_PISB_FILESIZE ) )
		goto _ERROR ;
	if ( fileSize < 12 )
		goto _ERROR ;
	if ( pFile == NULL )
	{
		if ( !( pPictureInfo->state & AC_PISB_FILEPATH ) )
			goto _ERROR ;
		hFile = CreateFile(
			pPictureInfo->pszFilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ;
		if ( hFile == INVALID_HANDLE_VALUE )
			goto _ERROR ;
		hFileMap = CreateFileMapping( hFile, NULL, PAGE_READONLY, 0, 0, NULL ) ;
		if ( hFileMap == NULL )
			goto _ERROR ;
		pFileMap = (LPBYTE)MapViewOfFile( hFileMap, FILE_MAP_READ, 0, 0, 0 ) ;
		if ( pFileMap == NULL )
			goto _ERROR ;
		pFile = pFileMap ;
	}

#if 1	/* APP1SOI̒ɂȂꍇ̂ŏύX ==> */
	{
		DWORD	addSize = 0 ;	/* pFile ւ̉Zl */

/* pFile Z}N */
#define ADD_pFile( size )\
	addSize += ( size ) ;\
	if ( addSize > fileSize )\
		goto _ERROR ;\
	pFile += ( size ) ;

		/* EXIFt@C`FbNAPP1}[J[̌ */
		if ( memcmp( pFile + 0, SOI, sizeof(SOI)) )
			goto _ERROR ;	/* JFIFłȂ */
		ADD_pFile( 2 );		/* }[J[TCYZ */
		for ( ; ; )
		{
			WORD	dataSize = 0 ;
			if ( memcmp( pFile, APP1, sizeof(APP1) ) == 0 )
				break ;	/* APP1}[J[𔭌 */
			if ( memcmp( pFile, EOI, sizeof(EOI) ) == 0 )
				goto _ERROR ;	/* APP1}[J[Ȃ */

			/* ̃}[J[ */
			ADD_pFile( 2 );		/* }[J[TCYZ */
			dataSize = _acGetWORD( pFile, TRUE ) ;
			ADD_pFile( dataSize ) ;		/* f[^TCYZ */
		}
		if ( memcmp( pFile + 4, EXIF, sizeof(EXIF) ) )
			goto _ERROR ;
		if ( !memcmp( pFile + 10, II, sizeof(II) ) )
			bBigEndian = FALSE ;	/* Ce` */
		else if ( !memcmp( pFile + 10, MM, sizeof(MM) ) )
			bBigEndian = TRUE ;		/* g[` */
		else
			goto _ERROR ;
		if ( _acGetWORD( pFile + 12, bBigEndian ) != 0x002A )
			goto _ERROR ;
		offset = _acGetDWORD( pFile + 14, bBigEndian ) ;
		pApp1 = pFile + 10 ;
	}
#else
	/* EXIFt@C`FbN */
	if ( memcmp( pFile + 0, SOI, sizeof(SOI)) )
		goto _ERROR ;
	if ( memcmp( pFile + 2, APP1, sizeof(APP1) ) )
		goto _ERROR ;
	if ( fileSize < (DWORD)_acGetWORD( pFile + 4, TRUE ) + 4 )
		goto _ERROR ;
	if ( memcmp( pFile + 6, EXIF, sizeof(EXIF) ) )
		goto _ERROR ;
	if ( !memcmp( pFile + 12, II, sizeof(II) ) )
		bBigEndian = FALSE ;	/* Ce` */
	else if ( !memcmp( pFile + 12, MM, sizeof(MM) ) )
		bBigEndian = TRUE ;		/* g[` */
	else
		goto _ERROR ;
	if ( _acGetWORD( pFile + 14, bBigEndian ) != 0x002A )
		goto _ERROR ;
	offset = _acGetDWORD( pFile + 16, bBigEndian ) ;
	pApp1 = pFile + 12 ;
#endif /* <== APP1SOI̒ɂȂꍇ̂ŏύX */

	/*  */
	pAutoCreate = (LPAUTOCREATE)calloc( 1, sizeof(AUTOCREATE) ) ;
	if ( pAutoCreate == NULL )
		goto _ERROR ;
	_acGetIFD( pAutoCreate, pApp1, offset, bBigEndian ) ;
	if ( pAutoCreate->attInfoNum == 0 && pAutoCreate->pszComment == NULL )
		goto _ERROR ;
	if ( pFileMap != NULL )
		UnmapViewOfFile( pFileMap ) ;
	if ( hFileMap != NULL )
		CloseHandle( hFileMap ) ;
	if ( hFile != INVALID_HANDLE_VALUE )
		CloseHandle( hFile ) ;
	return pAutoCreate ;

_ERROR:
	if ( pFileMap != NULL )
		UnmapViewOfFile( pFileMap ) ;
	if ( hFileMap != NULL )
		CloseHandle( hFileMap ) ;
	if ( hFile != INVALID_HANDLE_VALUE )
		CloseHandle( hFile ) ;
	if ( pAutoCreate != NULL )
		_acDelete( pAutoCreate ) ;
	return NULL ;
}

/* \̂j */
static void _acDelete( LPAUTOCREATE pAutoCreate )
{
	assert( pAutoCreate != NULL ) ;
	if ( pAutoCreate->pAttInfoArray != NULL )
	{
		UINT	i ;
		for ( i = 0 ; i < pAutoCreate->attInfoNum ; i ++ )
		{
			LPATTINFO	pAttInfo = pAutoCreate->pAttInfoArray + i ;
			if ( pAttInfo->pszName != NULL )
				free( pAttInfo->pszName ) ;
			if ( pAttInfo->pszCatPath != NULL )
				free( pAttInfo->pszCatPath ) ;
		}
		free( pAutoCreate->pAttInfoArray ) ;
	}
	if ( pAutoCreate->pszComment != NULL )
		free( pAutoCreate->pszComment ) ;
	free( pAutoCreate ) ;
}

/* ^Onh */
static void TAG_HANDLER_NAME( Model )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian )
{
	char	attName[256] ;

	assert( pDirEntry->type == TYPE_ASCII || pDirEntry->type == TYPE_UNDEFINED ) ;
	strcpy( attName, "(Exif)[J]:" ) ;
	if ( pDirEntry->count <= 4 )
		strcat( attName, (LPCSTR)&pDirEntry->value ) ;
	else
		strcat( attName, (LPCSTR)( pApp1 + pDirEntry->offset ) ) ;
	_acAddAttInfo( pAutoCreate, attName, "Exif\\J" ) ;
	_acSetComment( pAutoCreate, attName, FALSE ) ;

	UNUSED( bBigEndian ) ;
}
static void TAG_HANDLER_NAME( Artist )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian )
{
	char	attName[256] ;

	assert( pDirEntry->type == TYPE_ASCII || pDirEntry->type == TYPE_UNDEFINED ) ;
	strcpy( attName, "(Exif)[Җ]:" ) ;
	if ( pDirEntry->count <= 4 )
		strcat( attName, (LPCSTR)&pDirEntry->value ) ;
	else
		strcat( attName, (LPCSTR)( pApp1 + pDirEntry->offset ) ) ;
	_acAddAttInfo( pAutoCreate, attName, "Exif\\Җ" ) ;
	_acSetComment( pAutoCreate, attName, FALSE ) ;

	UNUSED( bBigEndian ) ;
}
static void TAG_HANDLER_NAME( ExifIFDPointer )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian )
{
	_acGetExifIFD( pAutoCreate, pApp1, pDirEntry->offset, bBigEndian ) ;
}
static void TAG_HANDLER_NAME( UserComment )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian )
{
	if ( pDirEntry->count > 8 )
	{
		size_t	len = pDirEntry->count - 8 ;
		LPSTR	pszComment = (LPSTR)calloc( 1, len + 1 ) ;
		if ( pszComment != NULL )
		{
			memcpy( pszComment, pApp1 + pDirEntry->offset + 8, len ) ;
			_acSetComment( pAutoCreate, "(Exif)[Rg]:", FALSE ) ;
			_acSetComment( pAutoCreate, pszComment, FALSE ) ;
			free( pszComment ) ;
		}
	}

	UNUSED( bBigEndian ) ;
}
static void TAG_HANDLER_NAME( DateTimeOriginal )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian )
{
	char			year[]		= "(Exif)[Be]:0000N" ;
	char			month[]		= "(Exif)[Be]:00" ;
	char			day[]		= "(Exif)[Be]:00" ;
	char			hour[]		= "(Exif)[Be]:00" ;
	char			minute[]	= "(Exif)[Be]:00" ;
	char			second[]	= "(Exif)[Be]:00b" ;
	char			comment[]	= "(Exif)[Be]:0000N0000000000b" ;
	LPCSTR			pszDate		= (LPCSTR)( pApp1 + pDirEntry->offset ) ;
	const size_t	offset		= strlen("(Exif)[Be]:");

	assert( pDirEntry->count == 20 ) ;
	memcpy( year	+ offset, pszDate + 0, 4 ) ;	/* N */
	memcpy( month	+ offset, pszDate + 5, 2 ) ;	/*  */
	memcpy( day		+ offset, pszDate + 8, 2 ) ;	/*  */
	memcpy( hour	+ offset, pszDate + 11, 2 ) ;	/*  */
	memcpy( minute	+ offset, pszDate + 14, 2 ) ;	/*  */
	memcpy( second	+ offset, pszDate + 17, 2 ) ;	/* b */
	_acAddAttInfo( pAutoCreate, year,	"Exif\\Be\\N" ) ;
	_acAddAttInfo( pAutoCreate, month,	"Exif\\Be\\" ) ;
	_acAddAttInfo( pAutoCreate, day,	"Exif\\Be\\" ) ;
	_acAddAttInfo( pAutoCreate, hour,	"Exif\\Be\\" ) ;
	_acAddAttInfo( pAutoCreate, minute,	"Exif\\Be\\" ) ;
	_acAddAttInfo( pAutoCreate, second,	"Exif\\Be\\b" ) ;

	memcpy( comment + offset +  0, pszDate + 0, 4 ) ;	/* N */
	memcpy( comment + offset +  6, pszDate + 5, 2 ) ;	/*  */
	memcpy( comment + offset + 10, pszDate + 8, 2 ) ;	/*  */
	memcpy( comment + offset + 14, pszDate + 11, 2 ) ;	/*  */
	memcpy( comment + offset + 18, pszDate + 14, 2 ) ;	/*  */
	memcpy( comment + offset + 22, pszDate + 17, 2 ) ;	/* b */
	_acSetComment( pAutoCreate, comment, FALSE ) ;

	UNUSED( bBigEndian ) ;
}
static void TAG_HANDLER_NAME( ExposureTime )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian )
{
	char	attName[256] ;
	ULONG	numerator ;		/* q */
	ULONG	denominator ;	/*  */
	assert( pDirEntry->type == TYPE_URATIONAL ) ;
	numerator		= (ULONG)_acGetDWORD( pApp1 + pDirEntry->offset + 0, bBigEndian ) ;
	denominator		= (ULONG)_acGetDWORD( pApp1 + pDirEntry->offset + 4, bBigEndian ) ;
	if ( denominator > numerator )
		sprintf( attName, "(Exif)[Vb^[Xs[h]:1/%db", denominator / numerator ) ;
	else
		sprintf( attName, "(Exif)[Vb^[Xs[h]:%1.1fb", numerator / (double)denominator) ;
	_acAddAttInfo( pAutoCreate, attName, "Exif\\Vb^[Xs[h" ) ;
	_acSetComment( pAutoCreate, attName, FALSE ) ;
}
static void TAG_HANDLER_NAME( ShutterSpeedValue )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian )
{
	char	attName[256] ;
	long	numerator ;		/* q */
	long	denominator ;	/*  */
	double	exposureTime ;

	assert( pDirEntry->type == TYPE_SRATIONAL ) ;
	numerator		= (long)_acGetDWORD( pApp1 + pDirEntry->offset + 0, bBigEndian ) ;
	denominator		= (long)_acGetDWORD( pApp1 + pDirEntry->offset + 4, bBigEndian ) ;
	exposureTime	= numerator / (double)denominator ;
	if ( exposureTime > 0 )
		sprintf( attName, "(Exif)[Vb^[Xs[h(APEX)]:%1.2f (Zl 1/%db)", exposureTime, (long)pow( 2, exposureTime ) ) ;
	else
		sprintf( attName, "(Exif)[Vb^[Xs[h(APEX)]:%1.2f (Zl %1.1fb)", exposureTime, 1 / pow( 2, exposureTime ) ) ;
	_acAddAttInfo( pAutoCreate, attName, "Exif\\Vb^[Xs[h(APEX)" ) ;
	_acSetComment( pAutoCreate, attName, FALSE ) ;
}
static void TAG_HANDLER_NAME( FNumber )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian )
{
	char	attName[256] ;
	ULONG	numerator ;		/* q */
	ULONG	denominator ;	/*  */
	double	fNumber ;

	assert( pDirEntry->type == TYPE_URATIONAL ) ;
	numerator		= (ULONG)_acGetDWORD( pApp1 + pDirEntry->offset + 0, bBigEndian ) ;
	denominator		= (ULONG)_acGetDWORD( pApp1 + pDirEntry->offset + 4, bBigEndian ) ;
	fNumber			= numerator / (double)denominator ;
	sprintf( attName, "(Exif)[il]:F%1.1f", fNumber ) ;
	_acAddAttInfo( pAutoCreate, attName, "Exif\\il" ) ;
	_acSetComment( pAutoCreate, attName, FALSE ) ;
}
static void TAG_HANDLER_NAME( ApertureValue )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian )
{
	char	attName[256] ;
	ULONG	numerator ;		/* q */
	ULONG	denominator ;	/*  */
	double	apertureValue ;

	assert( pDirEntry->type == TYPE_URATIONAL ) ;
	numerator		= (ULONG)_acGetDWORD( pApp1 + pDirEntry->offset + 0, bBigEndian ) ;
	denominator		= (ULONG)_acGetDWORD( pApp1 + pDirEntry->offset + 4, bBigEndian ) ;
	apertureValue	= numerator / (double)denominator ;
	sprintf( attName, "(Exif)[il(APEX)]:%1.2f (Zl F%1.1f)", apertureValue, sqrt( pow( 2, apertureValue ) ) ) ;
	_acAddAttInfo( pAutoCreate, attName, "Exif\\il(APEX)" ) ;
	_acSetComment( pAutoCreate, attName, FALSE ) ;
}
static void TAG_HANDLER_NAME( ISOSpeedRatings )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian )
{
	char	attName[256] ;
	USHORT	isoSpeedRatings ;

	assert( pDirEntry->type == TYPE_USHORT ) ;
	isoSpeedRatings = (WORD)_acGetWORD( (LPCBYTE)&pDirEntry->value, bBigEndian ) ;
	sprintf( attName, "(Exif)[ISOx]:%u", isoSpeedRatings ) ;
	_acAddAttInfo( pAutoCreate, attName, "Exif\\ISOx" ) ;
	_acSetComment( pAutoCreate, attName, FALSE ) ;

	UNUSED( pApp1 ) ;
}
static void TAG_HANDLER_NAME( FocalLength )( LPAUTOCREATE pAutoCreate, LPCDIRENTRY pDirEntry, LPCBYTE pApp1, BOOL bBigEndian )
{
	char	attName[256] ;
	ULONG	numerator ;		/* q */
	ULONG	denominator ;	/*  */
	assert( pDirEntry->type == TYPE_URATIONAL ) ;
	numerator		= (ULONG)_acGetDWORD( pApp1 + pDirEntry->offset + 0, bBigEndian ) ;
	denominator		= (ULONG)_acGetDWORD( pApp1 + pDirEntry->offset + 4, bBigEndian ) ;
	sprintf( attName, "(Exif)[Yœ_]:%1.1f mm", numerator / (double)denominator) ;
	_acAddAttInfo( pAutoCreate, attName, "Exif\\Yœ_" ) ;
	_acSetComment( pAutoCreate, attName, FALSE ) ;
}







